# -*- coding: utf-8 -*-
# AchtDamen_doof_Zeitmessung.py
### Hier werden jeweils nur die nachfolgenden Felder verwendet.

###                                      Version fuer Python 2.7
from __future__ import print_function
from Zeitmessung import Zeit
### ===== Suchraum ==================================================
def erzeugeFeld(maxZahl):
    feld=[]
    for i in range(1,maxZahl+1):
        zeile=[]
        for j in range(1,maxZahl+1):
            feld.append([i, j])
    return feld
    

def tiefensuche(maxZahl=4):
    def intern(alternativen, belegt):
        if len(belegt)==maxZahl:
            if zulaessig(belegt):
                return belegt
            return False
        if len(alternativen)==0:
            return False
        if not zulaessig(belegt):
            return False
        versuch = intern(alternativen[1:], [alternativen[0]]+belegt)
        if versuch:
            return versuch
        else:
            return intern(alternativen[1:], belegt)
    return intern(erzeugeFeld(maxZahl), [])

### ===== zulaessig ================================================
# Es wird nacheinander geprueft, ob sich Zeilen- oder Spaltenindizes
# und Diagonalendifferenzen wiederholen.
# uebergeben wird die liste der Belegungen
def zulaessig(belegt):
    for i in range(len(belegt)-1):
        for j in range(i+1, len(belegt)):
            x1,y1=belegt[i]
            x2,y2=belegt[j]
            ##input(((x1,y1),(x2,y2)))
            if x1==x2: return False          # gleiche Zeile
            if y1==y2: return False          # gleiche Spalte
            if x1-y1 == x2-y2: return False  # gleiche Diagonale ru
            if x1+y1 == x2+y2: return False  # gleiche Diagonale lu
    return True

### ===== Darstellung ============================================
def zeigeFeld(zustand, maxZahl=4):
    print(zustand)
    for i in range(maxZahl):
        for j in range(maxZahl):
            if [i+1,j+1] in zustand: print('D', end=' ')
            else: print('*', end=' ')
        print()
### ===== suche mit zeitmessung ==================================
import time
def SucheMitZeitmessung(maxZahl=8):
    print(maxZahl, " Damen:")
    zeit = Zeit()
    zeit.start()
    f=tiefensuche(maxZahl)
    zeit.stopp()
    zeigeFeld(f,maxZahl)
    print(zeit.zeigeDauer())
## ==============================================================
#zeigeFeld(tiefensuche())
SucheMitZeitmessung(4)
SucheMitZeitmessung(5)
SucheMitZeitmessung(6)
SucheMitZeitmessung(7)
SucheMitZeitmessung(8)

